#ifndef MACROS_AVANT_H
#define MACROS_AVANT_H

// pour indiquer quel est le type d'un produit
template <class T, class U> struct type_prod {}; 
#define PRODUIT(x,y,z) template<> struct type_prod<x, y>{ typedef z Z; }
//le produit des types x et y est z
//PRODUIT(double, IPoint, DPoint);
//pour: template<> struct type_prod<double, IPoint>{ typedef DPoint Z; };
PRODUIT(int, int, int);
PRODUIT(int, double, double);
PRODUIT(double, int, double);
PRODUIT(double, double, double);

// raccourci cool 
#define type_produit(x,y) typename type_prod<x,y>::Z 


// pour indiquer un type
// template <int s> struct type_deux {};
// int a; type_chaine(a) retourne "int"

#define TYPE_DE(x) string type_chaine(x){ return #x; } 

//  template<> struct type_deux<y>{ typedef x Z; }; 
  
TYPE_DE(int)
TYPE_DE(double)
TYPE_DE(string)
TYPE_DE(bool)

/*
int type_nombre(const string s){
  if (s == "int")
    return 0;
  else if (s == "double")
    return 1;
  return 42;
}
*/
// chaine_type(int) retourne "int"
#define chaine_type(x) type_chaine(x()) 
// type_de("int") retourne int
//#define type_de(x) typename type_deux< type_nombre(x) >::Z


#endif
